



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Redis非关系型数据库</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Redis非关系型数据库</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 14:39:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1.简介</h1>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201904/1337502-20190402104804046-119352996.png" /></p>
<p>Redis是一个基于内存的Key-Value非关系型数据库，由C语言进行编写。</p>
<p>Redis一般作为分布式缓存框架、分布式下的SESSION分离、分布式锁的实现等等。</p>
<p>Redis速度快的原因：基于内存、单线程、多路复用。</p>
<h1>2.Redis数据类型</h1>
<p>Redis中提供了七种数据类型，分别是String、Hash、List、Set、ZSet、HyperLogLog、BitMap。</p>
<h2>2.1 String</h2>
<p>Key对应的Value是一个字符串类型。</p>
<div>
<pre class="prettyprint linenums">#设置字符串类型的Key<br />
set key value

#仅当Key不存在时设置字符串类型的Key<br />
setnx key value

#设置字符串类型的Key并添加过期时间<br />
setex key second value

#获取Key对应的Value<br />
get key

#让Key对应的Value值递增1<br />
incr key

#让Key对应的Value值递减1<br />
decr key

#让Key对应的Value递增指定的数值<br />
incrby key num

#让Key对应的Value递减指定的数值<br />
decrby key num

#往Key对应的Value中追加字符串<br />
append key str</pre>
</div>
<p><strong>*</strong>在使用set、append命令时，如果Key不存在则创建，否则替换Key对应的Value值。</p>
<p><strong>*</strong>在使用incr、incrby、decr、decrby命令时，如果Key不存在则初始化为0后再进行操作，如果Key对应的Value不是数值类型字符串，那么将会报错。</p>
<h2>2.2 Hash</h2>
<p>Key对应的Value是一个哈希类型，每个哈希类型中都包含若干个键值对（属性名与属性值）</p>
<div>
<pre class="prettyprint linenums">#往Hash中添加一个属性<br />
hset key field value

#仅当Key不存在时往Hash中添加一个属性<br />
hsetnx key field value

#往Hash中添加多个属性<br />
hmset key field1 value1 field2 value2

#获取Hash中指定的一个属性<br />
hget key field

#获取Hash中指定的多个属性<br />
hmget key field1 field2

#获取Hash中所有的属性<br />
hgetall key

#让Hash中指定的属性递增指定的数值(属性值必须是数值类型)<br />
hincrby key field num

#判断Hash中指定的属性是否存在<br />
hexists key field

#获取Hash中属性的个数<br />
hlen key

#获取Hash中所有的属性名<br />
hkeys key

#获取Hash中所有的属性值<br />
hvals key

#删除Hash中指定的多个属性<br />
hdel key field1 field2</pre>
</div>
<p><strong>*</strong>在使用hset、hmset命令时，如果Key不存在则创建，否则往Key对应的Hash中添加属性，如果属性名相同则替换属性值。</p>
<p><strong>*</strong>Hash中只有hincryby命令，没有类似String的incr、decr、decrby命令。</p>
<p><strong>*</strong>当使用hdel命令删除了Hash中的所有属性，那么此时Key也会被删除。</p>
<h2>2.3 List</h2>
<p>Key对应的Value是一个List类型（列表对象，有序可重复）</p>
<div>
<pre class="prettyprint linenums">#从链表的左侧添加元素<br />
lpush key value

#从链表的右侧添加元素<br />
rpush key value

#仅当Key存在时从链表的左侧添加元素<br />
lpushx key value

#仅当Key存在时从链表的右侧添加元素<br />
rpushx key value

#获取链表中指定索引范围的元素(从链表的左侧开始遍历,包括begin和end的位置,如果end为-1表示倒数第一个元素)<br />
lrange key begin end

#从链表的左侧弹出一个元素<br />
lpop key

#从链表的右侧弹出一个元素<br />
rpop key

#获取链表中元素的个数<br />
llen key

#删除链表中指定个数个Value(若count为正数，则从链表的左侧开始删除指定个数个Value，若count为负数，则从链表的右侧开始删除指定个数个Value，若count为0，则删除链表中所有指定的Value)<br />
lrem key count value

#设置链表中指定索引的值<br />
lset key index value

#从链表的右侧弹出元素并将其放入到其他链表的左侧(一般用在消息队列的备份)<br />
rpoplpush key otherKey</pre>
</div>
<p><strong>*</strong>当使用lpush、rpush命令时，如果Key不存在则创建，否则往Key对应的链表中追加元素。</p>
<p><strong>*</strong>通过Redis的List可以实现队列和栈结构，当遵循lpush、rpop时，此时为队列结构，当遵循lpush、lpop时，此时为栈结构。</p>
<h2>2.4 Set</h2>
<p>Key对应的Value是一个Set（集合对象，无序不可重复）</p>
<div>
<pre class="prettyprint linenums">#往Set中添加元素<br />
sadd key value

#删除Set中指定的元素<br />
srem key value

#查看Set中的元素<br />
smembers key

#判断Set中是否包含某个元素<br />
sismemeber key value

#返回Set中元素的个数<br />
scard set

#返回两个Set的交集<br />
sinter set1 set2

#返回两个Set的并集<br />
sunion set1 set2

#返回Set1中Set2没有的元素(补集)<br />
sdiff set1 set2

#将Set1和Set2的交集放入到新的Set中<br />
sinterstore destSet set1 set2

#将Set1和Set2的并集放入到新的Set中<br />
sunionstore destSet set1 set2

#将Set1中Set2没有的元素放入到新的Set中<br />
sdiffstore destSet set1 set2</pre>
</div>
<p><strong>*</strong>在使用sadd命令时，如果Key不存在则创建，否则往Key对应的Set中追加元素。</p>
<h2>2.5 ZSet</h2>
<p>Key对应的Value是一个带分数的Set（有序集合对象，有序是相当于插入元素的顺序），其中分数可以相同但Value不能相同。</p>
<div>
<pre class="prettyprint linenums">#往ZSet中添加元素<br />
zadd key score value

#获取ZSet中指定Value的分数<br />
zscore key value

#返回ZSet中元素的个数<br />
zcard key

#获取ZSet中指定索引范围的元素(包括begin和end的位置,end为-1时表示倒数第一个元素)<br />
zrange key begin end

#获取ZSet中指定索引范围的元素以及分数,返回的元素按照分数从小到大排序<br />
zrange key begin end withscores

#获取ZSet中指定索引范围的元素以及分数,返回的元素按照分数从大到小进行排序<br />
zrevrange key begin end withscores

#获取ZSet中指定分数范围的元素(包括begin和end的位置)<br />
zrangebyscore key begin end

#获取ZSet中指定分数范围的元素并限制返回的个数<br />
zrangebyscore key begin end limit num

#返回ZSet中指定分数范围元素的个数<br />
zcount key begin end

#删除ZSet中指定的元素<br />
zrem key value

#删除ZSet中指定分数范围的元素(包括begin和end的位置)<br />
zremrangebyscore key begin end

#让ZSet中指定元素的分数递增指定的值<br />
zincrby key score value</pre>
</div>
<p><strong>*</strong>当使用zadd命令时，如果Key不存在则创建，否则往Key对应的ZSet中添加元素，如果Value相同则更新Score。</p>
<p><strong>*</strong>Set、ZSet中没有类似String、Hash、List的，当Key不存在或存在时才进行操作的命令。</p>
<h2>2.6 HyperLogLog</h2>
<p>Key对应的Value是一个HyperLogLog，用于做基数统计（支持在集群中使用）</p>
<div>
<pre class="prettyprint linenums">#往HyperLogLog中添加元素<br />
pfadd key value [value]

#统计HyperLogLog中的基数<br />
pfcount key

#将多个HyperLogLog合并成一个<br />
pfmerge destkey originKey [originKey...]</pre>
</div>
<p>HyperLogLog是用于做基数统计的算法，优点是在输入元素的数量或者体积非常大时，计算基数所需要的空间是固定的（12KB）</p>
<p>HyperLogLog只会根据输入元素来计算基数，并不会存储元素本身。</p>
<h2>2.7 BitMap</h2>
<p>Key对应的Value是一个BitMap（Bit数组），数组的大小被限制在512M之内，因此最大的长度为512 * 1024 * 1024个字节。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201908/1337502-20190830163223323-1346687512.png" /></p>
<div>
<pre class="prettyprint linenums">#设置bitMap，并指定offset，value取值为0或1<br />
setbit key offset value

#获取bitMap中指定offset的value<br />
getbit key offset

#返回bitMap中value为1的个数<br />
bitcount key

#进行bitMap之间的与、或、非、异或运算，并将运算后的结果放入目标bitmap<br />
bitop and/or/not/xor destKey sourceKey [sourceKey]</pre>
</div>
<p><strong>*</strong>可以使用BitMap来统计网站的日活跃度，userId即offset，当用户登录过则对应的offset设置为1，每天对应一个BitMap，使用bitcount命令可以统计一天当中的活跃度，使用bitop命令可以得到几天中不同维度的指标（连续登录、任意一天登录过）。</p>
<h2>2.8 通用命令</h2>
<div>
<pre class="prettyprint linenums">#查看Redis中的Key(支持通配符,*代表任意个字符,?代表任意一个字符)<br />
keys pattern

#删除Key<br />
del key

#判断Key是否存在<br />
exists key

#对Key进行重命名<br />
rename oldKey newKey

#对Key设置过期时间<br />
expire key seconds

#查看Key的有效时间(若Key没有设置过期时间则返回-1)<br />
ttl key

#查看Key的类型<br />
type key</pre>
</div>
<h1>3.Redis事务</h1>
<p>Redis中提供了事务的功能，Redis会将事务中的所有命令当作一个原子执行，即一个事务在执行时不会被其他命令所干扰。</p>
<div>
<pre class="prettyprint linenums">#开启事务<br />
multi

#执行事务<br />
exec

#放弃事务<br />
discard</pre>
</div>
<p><strong>*</strong>在Shell中事务与客户端进行绑定，当一个客户端开启了事务后，该客户端事务之后的命令都将放入一个新的队列中，使用exec命令执行事务，其他客户端的命令并不会进入此事务，在Jedis中通过Transaction实例封装一个事务，不受影响。</p>
<h1>4.Redis持久化</h1>
<p>由于Redis是基于内存的Key-Value非关系型数据库，因此当Redis服务挂掉后由于内存被释放会导致数据丢失，此时可以使用Redis的持久化功能。</p>
<h2>4.1 RDB持久化方式</h2>
<p>RDB持久化方式即Redis每隔一定时间，就会将当前内存中的所有Key-Value写入到磁盘文件中（全量写入），当Redis服务重启时，读取RDB文件自动进行数据的恢复。</p>
<p>RDB持久化方式是默认开启的，可以通过redis.conf配置文件中修改相关配置。</p>
<div>
<pre class="prettyprint linenums">#在900秒内如果至少有1个Key发生变化,那么执行一次写入操作<br />
save 900 1

#在300秒内如果至少有10个Key发生改变,那么执行一次写入操作<br />
save 300 10

#在60秒内如果至少有10000个Key发生改变,那么执行一次写入操作<br />
save 60 10000

#rdb文件的保存路径(相对于redis.conf文件)<br />
dir ./

#rdb文件的名称<br />
dbfilename dump.rdb</pre>
</div>
<p><strong>*</strong>使用RDB持久化方式有很大可能会发生Key的修改未来得及写入到磁盘中服务器就宕机了（可以调整默认的同步策略）</p>
<p><strong>*</strong>RDB持久化方式由Redis进程执行fork操作创建子进程来完成，因此阻塞只会发生在fork阶段，客户端可以通过save、bgsave命令手动触发RDB操作，其中save命令会阻塞redis进程直到RDB持久化完成，而bgsave命令由redis进程fork子进程进行完成。</p>
<h2>4.2 AOF持久化方式</h2>
<p>AOF持久化方式即Redis将所有的Key-Value操作都写入到日志文件中（追加，增量写入），当Redis服务重启时，读取AOF文件自动进行数据的恢复。</p>
<p>AOF持久化方式提供了三种同步策略：每修改同步、每秒同步、不同步。</p>
<div>
<pre class="prettyprint linenums">#开启AOF方式<br />
appendonly yes

#AOF文件名<br />
appendfilename "appendonly.aof"

#AOF同步策略<br />
#每修改同步<br />
appendsync always

#每秒同步<br />
appendsync everysec

#不同步<br />
appendsync no</pre>
</div>
<p><strong>*</strong>AOF持久化方式也是由Redis进程执行fork操作创建子进程来完成，并且当日志文件达到一定大小时Redis会对其压缩（重写）</p>
<p><strong>*</strong>当同时使用RDB和AOF持久化方式时，数据的恢复将固定使用AOF的。</p>
<p>RDB持久化方式与AOF持久化方式的对比</p>
<p>1.文件大小：AOF持久化方式所产生的日志文件要比RDB持久化方式所产生的rdb文件要大。</p>
<p>2.安全性：AOF持久化方式数据丢失的可能性要比RDB持久化方式低。</p>
<p>3.效率：AOF持久化方式在进行数据恢复时的效率要比RDB持久化方式的低。</p>
<h1>5.Redis过期清除策略以及内存淘汰机制</h1>
<h2>5.1 Redis过期清除策略</h2>
<p>Redis中可以对Key设置过期时间，当Key已经到达过期时间时，并不会立即被删除，而是通过Redis的过期策略进行处理。</p>
<p>Redis中使用惰性删除和主动删除两种过期策略：</p>
<p>惰性删除：当访问一个已经过期的Key时，将该Key删除。</p>
<p>主动删除：Redis定时删除缓存中部分过期的Key，通过抽样的方式保证Redis中过期的Key在低于25%以下。</p>
<p><strong>*</strong>Redis定时删除缓存中部分过期的Key是通过Redis常规任务处理的，常规任务还包含其他一些任务处理，可以通过修改redis.conf配置文件中的hz参数来调整Redis常规任务的执行频率，默认值是10，表示每秒执行10次，其取值为1~500，但Redis不建议该值超过100，否则会影响其他的业务请求，造成延时。</p>
<h2>5.2 Redis内存淘汰机制</h2>
<p>当Redis中有效数据使用的内存大小达到预配置的maxmemory时，将会触发Redis的内存淘汰机制，按预先设置的淘汰策略主动删除缓存中部分的Key。</p>
<p>Redis中提供了六种淘汰策略：</p>
<p>1.allkeys-lru（推荐）：删除部分最近最少使用的Key。</p>
<p>2.volatile-lru：在设置了过期时间的Key中，删除部分最近最少使用的Key。</p>
<p>3.allkeys-random：随机删除部分Key。</p>
<p>4.volatile-random：随机删除部分设置了过期时间的Key。</p>
<p>5.volatile-ttl：删除部分即将过期的Key。</p>
<p>6.noeviction：不清除，对于写请求直接返回错误。</p>
<p><strong>*</strong>可以通过redis.conf配置文件中的maxmemory-policy参数设置Redis的淘汰策略。</p>
<h1>6.Redis其他的常用应用场景</h1>
<h2>6.1 基于Redis实现分布式锁</h2>
<p>一般通过Redis中的一个Key来实现分布式锁，当Key已经存在时，表示当前锁已经被其它线程锁持有，当Key不存在时，设置Key，表示获取锁资源。</p>
<p>分布式锁可能面临的问题：</p>
<p>1.当系统宕机时如何保证锁能够被释放？</p>
<p><strong>*</strong>通过对Key设置过期时间，当Key已经过期并再次访问时，通过惰性删除过期策略删除该Key。</p>
<p>2.怎样保证获取锁时的同步问题？</p>
<p><strong>*</strong>通过使用Redis提供的set(String key, String value, String nxxx, String expx, long time)命令，将判断Key是否存在以及设置Key作为一个原子操作。</p>
<p>3.怎样保证释放的锁是当前线程的？</p>
<p><strong>*</strong>给Key设置一个代表当前线程的Value，当删除该Key时判断Value是否属于当前线程的。</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * 获取锁<br />
 */<br />
public boolean getLock(String key, String value, int second) {<br />
    return "OK".equalsIgnoreCase(jedis.set(key, value, "nx", "ex", second));<br />
}

/**<br />
 * 释放锁<br />
 */<br />
public boolean unLock(String key, String value) {<br />
    if (value.equals(jedis.get(key))) {<br />
        jedis.del(key);<br />
        return true;<br />
    }<br />
    return false;<br />
}</pre>
</div>
<h2>6.2 基于Redis的计数器实现频次控制、数量控制、数量统计</h2>
<p>Redis计数器即使用incr、incrby、decr、decrby命令，将Key对应的Value递增或递减指定的数值。</p>
<p><strong>频次控制</strong>（登录错误次数）</p>
<p>1.用户输入用户名以及密码，首先判断代表用户的Key是否存在，仅当Key不存在或Key的值小于所允许的最大登录错误次数时，执行登录操作，否则不允许登录。</p>
<p>2.执行登录操作，如果登录成功则将用户实体放入HttpSession，否则当密码错误时，使用incr命令自增1（Key不存在时初始化为0再操作），并根据命令返回值判断当前的错误次数是否已经达到了所允许的最大值，若达到了则设置Key的过期时间。</p>
<p><strong>数量控制</strong>（秒杀、抢购）</p>
<p>1.系统在抢购前初始化该Key对应的Value。</p>
<p>2.在进行抢购时直接使用decr命令，并根据返回值判断是否抢购成功，当返回值大于等于0，表示抢购成功，否则抢购失败。</p>
<p><strong>*</strong>依赖incr、incrby、decr、decrby命令的返回值，可以避免并发导致的同步问题（不需要获取值再判断是否大于0，因为不是原子操作，会有同步问题）</p>
<p><strong>*</strong>一般对于频次控制、数量统计，使用incr、incrby命令，对于数量控制使用decr、decrby命令。</p>
<h1>7.使用Redis时面临的问题</h1>
<h2>7.1 缓存雪崩</h2>
<p>缓存雪崩即Redis中有大部分的Key集中过期，那么此时所有的客户端请求都会去到数据库中，从而增加了数据库的压力。</p>
<p><strong>*</strong>解决缓存雪崩的方法是对于被频繁访问的Key不设置过期时间，对于不频繁访问的Key分散设置过期时间。</p>
<h2>7.2 缓存穿透</h2>
<p>缓存穿透即不断查询Redis中不存在Key，从而占用Redis以及数据库的连接，容易被恶意占用资源。</p>
<p><strong>*</strong>解决缓存穿透的方法是当数据库查询不到记录时，也将该Key放入到缓存中，其Value是一个空字符串。</p>
<h2>7.3 缓存击穿</h2>
<p>缓存击穿即Redis中一个被高并发访问的Key突然过期，那么此时将会有大量的请求直接去到数据库，从而增加了数据库的压力。</p>
<p><strong>*</strong>解决缓存击穿的方法是对于被频繁访问的Key不设置过期时间。</p>
<h1>8.Redis的安装</h1>
<p>1.下载<a href="https://redis.io/" rel="external nofollow noreferrer">Redis源码</a>并进行解压</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201904/1337502-20190402165038176-1533886871.png" /></p>
<p>2.由于Redis是使用C语言编写的，因此需要安装gcc编译器，并使用make命令进行编译</p>
<div>
<pre class="prettyprint linenums">make</pre>
</div>
<p>3.进行redis的安装</p>
<div>
<pre class="prettyprint linenums">make PREFIX=/usr/redis install</pre>
</div>
<p><strong>*</strong>安装完后生成bin目录，里面包含一些Redis的可执行命令。</p>
<p>4.将redis源码目录下的redis.conf配置文件复制到安装目录中，并将配置文件中的daemonize改为yes，通过后台的方式启动Redis</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201904/1337502-20190402170550094-348086340.png" /></p>
<p>5.启动Redis Server</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201904/1337502-20190402170727281-480401060.png" /></p>
<p><strong>*</strong>Redis Server是一个进程，包含了若干个线程，但只有一个线程用于处理客户端的请求（Redis单线程处理任务，不会出现共享变量不一致的问题）</p>
<p>6.启动Redis Client</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1337502/201904/1337502-20190402170818692-635272772.png" /></p>
<p><strong>*</strong>Redis Server中包含16个数据库，编号从0~15，每个数据库之间的数据相互独立，客户端默认连接的是第一个数据库，可以通过select num命令修改连接的数据库。</p>
<h1>9.Java中使用Redis</h1>
<p>Jedis是Redis官方推荐的Redis Java客户端类库。</p>
<p>1.导入依赖</p>
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
    &lt;groupId&gt;redis.clients&lt;/groupId&gt;<br />
    &lt;artifactId&gt;jedis&lt;/artifactId&gt;<br />
    &lt;version&gt;3.0.1&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div>
<p>2.获取Redis连接</p>
<div>
<pre class="prettyprint linenums">//1.直接创建Jedis实例<br />
Jedis jedis = new Jedis(String host , int port);

//2.通过Jedis连接池来管理连接<br />
JedisPoolConfig poolConfig = new JedisPoolConfig();<br />
//最大连接数<br />
poolConfig.setMaxTotal(int num);<br />
//最大空闲连接数<br />
poolConfig.setMaxIdle(int num);

//创建连接池对象<br />
JedisPool jedisPool = new JedisPool(poolConfig , String host , int port);<br />
//获取Redis连接<br />
Jedis jedis = jedisPool.getResource();</pre>
</div>
<p><strong>*</strong>当Redis连接使用完毕后需要手动关闭。</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * @Auther: ZHUANGHAOTANG<br />
 * @Date: 2019/4/2 17:11<br />
 * @Description:<br />
 */<br />
public class RedisUtils {

    private static final String host = "192.168.1.80";

    private static final int port = 6379;

    private static JedisPool jedisPool = null;

    static {<br />
        JedisPoolConfig poolConfig = new JedisPoolConfig();<br />
        //最大连接数<br />
        poolConfig.setMaxTotal(10);<br />
        //最大空闲连接数<br />
        poolConfig.setMaxIdle(5);<br />
        //创建连接池对象<br />
        jedisPool = new JedisPool(poolConfig, host, port);<br />
    }

    public static Jedis getConnection() {<br />
        return jedisPool.getResource();<br />
    }

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mg7eq.html">《使用Hibernate开发租房系统》内部测试笔试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzrgx9.html">jquery选择器和基本语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kn6yr8.html">Android判断网路是否畅通加权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mkzd0q.html">Handlebars模板库浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgro3q.html">2329&colon; &lbrack;HNOI2011&rsqb;括号修复 - BZOJ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzedpq.html">android gridview按钮边框和定制点击颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnj33d8.html">IS脚本学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0wpyeq.html">VS2010常用的调试方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylk0k9.html">sql server 多行数据合并成一列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzorgl8.html">Pycharm配置Git和Github</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpkkk8.html">Y1S002 xshell脚本编写示意</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z6jo19.html">Java开发笔记（八）五种算术运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2xlz8.html">nginx系列1：认识nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1mw79.html">&lowbar;&lowbar;x&lowbar;&lowbar;&lpar;21&rpar;0907第四天&lowbar;&lowbar; css 盒模型 &lpar;框模型&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3ro09.html">MyISAM索引和InnoDB索引的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6zy19.html">【java】模板方法设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1vwng9.html">Pascal语言（存档）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dgwl9.html">VM无法连接到虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvprjr8.html">struts2返回json数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjg4rr9.html">结合sklearn的可视化工具Yellowbrick：超参与行为的可视化带来更优秀的实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gewjze8.html">Jmeter简单回顾</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4lzk9.html">20年硅谷技术牛人到访DataPipeline谈：技术如何与业务平衡发展</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pe7338.html">Java设置接口跨域</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zrllx9.html">July 11th&comma; 2018&period; Wednesday&comma; Week 28th&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkvo5e8.html">memcached 学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj25xk8.html">来自学长&amp;amp&semi;师兄们的应届校招经验</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp75o69.html">js获取数组中最大值，最小值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkvexz8.html">CMake与Make最简单直接的区别 &lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mgew38.html">六 Struts 拦截器、OGNL表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4v4e9.html">RB-Tree插入过程详解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
